
// AutoDetectTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AutoDetectTest.h"
#include "AutoDetectTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CAutoDetectTestDlg dialog
CAutoDetectTestDlg::CAutoDetectTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAutoDetectTestDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAutoDetectTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_List);
	DDX_Control(pDX, IDC_INFO, m_Info);
	DDX_Control(pDX, IDC_START, m_Start);
	DDX_Control(pDX, IDC_STOP, m_Stop);
}

BEGIN_MESSAGE_MAP(CAutoDetectTestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &CAutoDetectTestDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &CAutoDetectTestDlg::OnBnClickedStop)
	ON_WM_TIMER()
END_MESSAGE_MAP()

// CAutoDetectTestDlg message handlers
BOOL CAutoDetectTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	if( !InitAll() ) {
		EndDialog(IDCANCEL);
	}
	m_strInfo.Empty();
	m_Start.EnableWindow(TRUE);
	m_Stop.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAutoDetectTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAutoDetectTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAutoDetectTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CAutoDetectTestDlg::OnBnClickedStart()
{
	if( StartGPICheck() ) {
		m_Start.EnableWindow(FALSE);
		m_Stop.EnableWindow(TRUE);
		SetTimer(101,10,NULL);
	}
	m_strInfo = _T("Start AutoDetect checking...");
	m_Info.SetWindowText(m_strInfo);
}

void CAutoDetectTestDlg::OnBnClickedStop()
{
	KillTimer(101);
	StopGPICheck();
	m_Start.EnableWindow(TRUE);
	m_Stop.EnableWindow(FALSE);
}

void CAutoDetectTestDlg::OnTimer(UINT_PTR nIDEvent)
{
	static bool bInTimer = false;
	if( !bInTimer ) {
		bInTimer = true;
		if( CheckGPI() ) {
			m_Info.SetWindowText(m_strInfo);
		}
		bInTimer = false;
	}
	CDialog::OnTimer(nIDEvent);
}

// !!!!!!!!!!!!!!!!!!! Real Code !!!!!!!!!!!!!!!!!!!!!

bool CAutoDetectTestDlg::InitAll()
{
	// create GPI manager
	HRESULT hres = m_pIMgr.CoCreateInstance(CLSID_SLGPIMgr);
	ATLASSERT(S_OK==hres);
	if( S_OK != hres )  return false;
	// init manager by AutoDetect only
	hres = m_pIMgr->Rescan(GPIT_AutoDetect_m);
	ATLASSERT(S_OK==hres);
	if( S_OK != hres )  return false;
	// scan all GPI-s
	long nIndex = 0;
	while( S_OK == hres ) {
		CComBSTR bstr;  CGPITypes type;
		hres = m_pIMgr->GetNextValidGPIInfo(&nIndex, &bstr, &type);
		if( S_OK != hres )  break;
		// add next GPI into list
		CString str(bstr);
		m_List.AddString(str);
	}
	m_List.SetCurSel(0);
	return true;
}

bool CAutoDetectTestDlg::StartGPICheck()
{
	// obtain selected name
	CString str;
	int n = m_List.GetCurSel();
	if( n < 0 )  return false;
	m_List.GetLBText(n,str);
	// open current GPI
	CComBSTR bstr(str);  CComPtr<IUnknown> pIUnk;
	HRESULT hres = m_pIMgr->CreateGPIByName(bstr, &pIUnk);
	ATLASSERT(S_OK==hres);
	if( S_OK != hres )  return false;
	hres = pIUnk->QueryInterface(&m_pGPI);
	ATLASSERT(S_OK==hres);
	if( S_OK != hres )  return false;
	hres = pIUnk->QueryInterface(&m_pGPITime);
	ATLASSERT(S_OK==hres);
	if( S_OK != hres )  return false;
	// save current GPI state
	long tmp;
	hres = m_pGPI->GetStats(&m_nCntUp, &tmp, &tmp);
	ATLASSERT(S_OK==hres);
	if( S_OK != hres )  return false;
	return true;
}

void CAutoDetectTestDlg::StopGPICheck()
{
	m_pGPI = NULL;
	m_pGPITime = NULL;
}

bool CAutoDetectTestDlg::CheckGPI()
{
	if( NULL==m_pGPI || NULL==m_pGPITime )  return false;
	// obtain current GPI state
	long tmp,cntUp;
	HRESULT hres = m_pGPI->GetStats(&cntUp, &tmp, &tmp);
	ATLASSERT(S_OK==hres);
	if( S_OK != hres )  return false;
	if( cntUp != m_nCntUp ) {
		// was GPI event
		DWORD msUp,tmp;
		hres = m_pGPITime->GetLastChangeTime(&msUp, &tmp);
		ATLASSERT(S_OK==hres);
		if( S_OK != hres )  return false;
		long delta = (long)(msUp - GetTickCount());
		CTime time = CTime::GetCurrentTime();
		if( delta < 0  ||  delta > 10000 ) // wrang future time - ignore it
			delta = 0;
		m_strInfo.Format(_T("Event at time %s with delay %d ms"), time.Format(_T("%X")), delta);
		m_nCntUp = cntUp;
	}
	return true;
}
